--- a/auth_changepassword.php
+++ b/auth_changepassword.php
@@ -59,6 +59,8 @@
 					header("Location: index.php"); break;
 				case '3': /* default graph page */
 					header("Location: graph_view.php"); break;
+				default:
+					api_plugin_hook_function('login_options_navigate', $user['login_opts']);
 			}
 		}else{
 			header("Location: graph_view.php");
--- a/auth_login.php
+++ b/auth_login.php
@@ -124,10 +124,12 @@
 		}
 
 	default:
-		/* Builtin Auth */
-		if ((!$user_auth) && (!$ldap_error)) {
-			/* if auth has not occured process for builtin - AKA Ldap fall through */
-			$user = db_fetch_row("SELECT * FROM user_auth WHERE username = '" . $username . "' AND password = '" . md5(get_request_var_post("login_password")) . "' AND realm = 0");
+		if (!api_plugin_hook_function('login_process', false)) {
+			/* Builtin Auth */
+			if ((!$user_auth) && (!$ldap_error)) {
+				/* if auth has not occured process for builtin - AKA Ldap fall through */
+				$user = db_fetch_row("SELECT * FROM user_auth WHERE username = '" . $username . "' AND password = '" . md5(get_request_var_post("login_password")) . "' AND realm = 0");
+			}
 		}
 	}
 	/* end of switch */
@@ -189,29 +191,42 @@
 		decide what to do next */
 		switch ($user["login_opts"]) {
 			case '1': /* referer */
-				if (sizeof(db_fetch_assoc("SELECT realm_id FROM user_auth_realm WHERE realm_id = 8 AND user_id = " . $_SESSION["sess_user_id"])) == 0) {
-					header("Location: graph_view.php");
-				}else{
-					if (isset($_SERVER["HTTP_REFERER"])) {
-						$referer = $_SERVER["HTTP_REFERER"];
-						if (basename($referer) == "logout.php") {
-							$referer = "index.php";
-						}
-					} else if (isset($_SERVER["REQUEST_URI"])) {
-						$referer = $_SERVER["REQUEST_URI"];
-						if (basename($referer) == "logout.php") {
-							$referer = "index.php";
-						}
-					} else {
-						$referer = "index.php";
+				/* because we use plugins, we can't redirect back to graph_view.php if they don't
+				 * have console access
+				 */
+				if (isset($_SERVER["HTTP_REFERER"])) {
+					$referer = $_SERVER["HTTP_REFERER"];
+					if (basename($referer) == "logout.php") {
+						$referer = $config['url_path'] . "index.php";
+					}
+				} else if (isset($_SERVER["REQUEST_URI"])) {
+					$referer = $_SERVER["REQUEST_URI"];
+					if (basename($referer) == "logout.php") {
+						$referer = $config['url_path'] . "index.php";
 					}
+				} else {
+					$referer = $config['url_path'] . "index.php";
+				}
+
+				if (substr_count($referer, "plugins")) {
 					header("Location: " . $referer);
+				} elseif (sizeof(db_fetch_assoc("SELECT realm_id FROM user_auth_realm WHERE realm_id = 8 AND user_id = " . $_SESSION["sess_user_id"])) == 0) {
+					header("Location: graph_view.php");
+				} else {
+					header("Location: $referer");
 				}
+
 				break;
 			case '2': /* default console page */
-				header("Location: index.php"); break;
+				header("Location: " . $config['url_path'] . "index.php");
+
+				break;
 			case '3': /* default graph page */
-				header("Location: graph_view.php"); break;
+				header("Location: " . $config['url_path'] . "graph_view.php");
+
+				break;
+			default:
+				api_plugin_hook_function('login_options_navigate', $user['login_opts']);
 		}
 		exit;
 	}else{
@@ -264,9 +279,17 @@
 <body bgcolor="#FFFFFF" onload="document.login.login_username.focus()">
 	<form name="login" method="post" action="<?php print basename($_SERVER["PHP_SELF"]);?>">
 	<input type="hidden" name="action" value="login">
+<?php
+
+api_plugin_hook("login_before");
+
+$cacti_logo = $config['url_path'] . 'images/auth_login.gif';
+$cacti_logo = api_plugin_hook_function('cacti_image', $cacti_logo);
+
+?>
 	<table align="center">
 		<tr>
-			<td colspan="2"><img src="images/auth_login.gif" border="0" alt=""></td>
+			<td colspan="2"><center><?php if ($cacti_logo != '') { ?><img src="<?php echo $cacti_logo; ?>" border="0" alt=""><?php } ?></center></td>
 		</tr>
 		<?php
 
@@ -303,22 +326,29 @@
 			<td><input type="password" name="login_password" size="40" style="width: 295px;"></td>
 		</tr>
 		<?php
-		if (read_config_option("auth_method") == "3") {?>
+		if (read_config_option("auth_method") == "3" || api_plugin_hook_function('login_realms_exist')) {
+			$realms = api_plugin_hook_function('login_realms', array("local" => array("name" => "Local", "selected" => false), "ldap" => array("name" => "LDAP", "selected" => true)));
+			?>
 		<tr>
 			<td>Realm:</td>
 			<td>
-				<select name="realm" style="width: 295px;">
-					<option value="local">Local</option>
-					<option value="ldap" selected>LDAP</option>
+				<select name="realm" style="width: 295px;"><?php
+				if (sizeof($realms)) {
+				foreach($realms as $name => $realm) {
+					print "\t\t\t\t\t<option value='" . $name . "'" . ($realm["selected"] ? " selected":"") . ">" . htmlspecialchars($realm["name"]) . "</option>\n";
+				}
+				}
+				?>
 				</select>
 			</td>
-			</tr>
+		</tr>
 		<?php }?>
 		<tr style="height:10px;"><td></td></tr>
 		<tr>
 			<td><input type="submit" value="Login"></td>
 		</tr>
 	</table>
+<?php api_plugin_hook('login_after'); ?>
 	</form>
 </body>
 </html>
--- a/graph.php
+++ b/graph.php
@@ -32,6 +32,8 @@
 include_once("./lib/html_tree.php");
 include_once("./include/top_graph_header.php");
 
+api_plugin_hook_function('graph');
+
 /* ================= input validation ================= */
 input_validate_input_regex(get_request_var("rra_id"), "^([0-9]+|all)$");
 input_validate_input_number(get_request_var("local_graph_id"));
@@ -94,17 +96,18 @@
 					<table width='1' cellpadding='0'>
 						<tr>
 							<td>
-								<img class='graphimage' id='graph_<?php print $_GET["local_graph_id"] ?>' src='<?php print htmlspecialchars("graph_image.php?action=view&local_graph_id=" . $_GET["local_graph_id"] . "&rra_id=" . $rra["id"]);?>' border='0' alt='<?php print htmlspecialchars($graph_title);?>'>
+									<img class='graphimage' id='graph_<?php print $_GET["local_graph_id"] ?>' src='<?php print htmlspecialchars("graph_image.php?action=view&local_graph_id=" . $_GET["local_graph_id"] . "&rra_id=" . $rra["id"]);?>' border='0' alt='<?php print htmlspecialchars($graph_title);?>'>
 							</td>
 							<td valign='top' style='padding: 3px;' class='noprint'>
 								<a href='<?php print htmlspecialchars("graph.php?action=zoom&local_graph_id=" . $_GET["local_graph_id"]. "&rra_id=" . $rra["id"] . "&view_type=" . $_REQUEST["view_type"]);?>'><img src='images/graph_zoom.gif' border='0' alt='Zoom Graph' title='Zoom Graph' style='padding: 3px;'></a><br>
 								<a href='<?php print htmlspecialchars("graph_xport.php?local_graph_id=" . $_GET["local_graph_id"] . "&rra_id=" . $rra["id"] . "&view_type=" . $_REQUEST["view_type"]);?>'><img src='images/graph_query.png' border='0' alt='CSV Export' title='CSV Export' style='padding: 3px;'></a><br>
 								<a href='<?php print htmlspecialchars("graph.php?action=properties&local_graph_id=" . $_GET["local_graph_id"] . "&rra_id=" . $rra["id"] . "&view_type=" . $_REQUEST["view_type"]);?>'><img src='images/graph_properties.gif' border='0' alt='Graph Source/Properties' title='Graph Source/Properties' style='padding: 3px;'></a>
+								<?php api_plugin_hook('graph_buttons', array('hook' => 'view', 'local_graph_id' => $_GET['local_graph_id'], 'rra' => $rra['id'], 'view_type' => $_REQUEST['view_type'])); ?>
 							</td>
 						</tr>
 						<tr>
 							<td colspan='2' align='center'>
-								<strong><?php print htmlspecialchars($rra["name"]);?></strong>
+									<strong><?php print htmlspecialchars($rra["name"]);?></strong>
 							</td>
 						</tr>
 					</table>
@@ -215,6 +218,7 @@
 					<td valign='top' style='padding: 3px;' class='noprint'>
 						<a href='<?php print htmlspecialchars("graph.php?action=properties&local_graph_id=" . $_GET["local_graph_id"] . "&rra_id=" . $_GET["rra_id"] . "&view_type=" . $_REQUEST["view_type"] . "&graph_start=" . $graph_start . "&graph_end=" . $graph_end);?>'><img src='images/graph_properties.gif' border='0' alt='Graph Source/Properties' title='Graph Source/Properties' style='padding: 3px;'></a>
 						<a href='<?php print htmlspecialchars("graph_xport.php?local_graph_id=" . $_GET["local_graph_id"] . "&rra_id=" . $_GET["rra_id"] . "&view_type=" . $_REQUEST["view_type"]);?>&graph_start=<?php print $graph_start;?>&graph_end=<?php print $graph_end;?>'><img src='images/graph_query.png' border='0' alt='CSV Export' title='CSV Export' style='padding: 3px;'></a><br>
+						<?php api_plugin_hook('graph_buttons', array('hook' => 'zoom', 'local_graph_id' => $_GET['local_graph_id'], 'rra' =>  $_GET['rra_id'], 'view_type' => $_REQUEST['view_type'])); ?>
 					</td>
 				</tr>
 				<tr>
@@ -247,6 +251,7 @@
 					<td valign='top' style='padding: 3px;'>
 						<a href='<?php print htmlspecialchars("graph.php?action=zoom&local_graph_id=" . $_GET["local_graph_id"] . "&rra_id=" . $_GET["rra_id"] . "&view_type=" . $_REQUEST["view_type"]);?>'><img src='images/graph_zoom.gif' border='0' alt='Zoom Graph' title='Zoom Graph' style='padding: 3px;'></a><br>
 						<a href='<?php print htmlspecialchars("graph_xport.php?local_graph_id=" . $_GET["local_graph_id"] . "&rra_id=" . $_GET["rra_id"] . "&view_type=" . $_REQUEST["view_type"]);?>'><img src='images/graph_query.png' border='0' alt='CSV Export' title='CSV Export' style='padding: 3px;'></a><br>
+						<?php api_plugin_hook('graph_buttons', array('hook' => 'properties', 'local_graph_id' => $_GET['local_graph_id'], 'rra' =>  $_GET['rra_id'], 'view_type' => $_REQUEST['view_type'])); ?>
 					</td>
 				</tr>
 				<tr>
--- a/graph_image.php
+++ b/graph_image.php
@@ -44,6 +44,8 @@
 /* flush the headers now */
 ob_end_clean();
 
+api_plugin_hook_function('graph_image');
+
 session_write_close();
 
 $graph_data_array = array();
--- a/graphs.php
+++ b/graphs.php
@@ -45,6 +45,8 @@
 	4 => "Convert to Graph Template"
 	);
 
+$graph_actions = api_plugin_hook_function('graphs_action_array', $graph_actions);
+
 /* set default action */
 if (!isset($_REQUEST["action"])) { $_REQUEST["action"] = ""; }
 
@@ -362,6 +364,8 @@
 
 				api_resize_graphs($selected_items[$i], $_POST["graph_width"], $_POST["graph_height"]);
 			}
+		} else {
+			api_plugin_hook_function('graphs_action_execute', $_POST['drp_action']);
 		}
 
 		header("Location: graphs.php");
@@ -514,6 +518,12 @@
 				";
 
 			$save_html = "<input type='button' value='Cancel' onClick='window.history.back()'>&nbsp;<input type='submit' value='Continue' title='Resize Selected Graph(s)'>";
+		} else {
+			$save['drp_action'] = $_POST['drp_action'];
+			$save['graph_list'] = $graph_list;
+			$save['graph_array'] = (isset($graph_array) ? $graph_array : array());
+			api_plugin_hook_function('graphs_action_prepare', $save);
+			$save_html = "<input type='button' value='Cancel' onClick='window.history.back()'>&nbsp;<input type='submit' value='Continue'>";
 		}
 	}else{
 		print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one graph.</span></td></tr>\n";
--- a/graphs_new.php
+++ b/graphs_new.php
@@ -511,7 +511,8 @@
 			</td>
 			<td nowrap style='white-space: nowrap;' class="textInfo" align="center" valign="top">
 				<span style="white-space: nowrap; color: #c16921;">*</span><a href="<?php print htmlspecialchars("host.php?action=edit&id=" . $_REQUEST["host_id"]);?>">Edit this Host</a><br>
-				<span style="white-space: nowrap; color: #c16921;">*</span><a href="<?php print htmlspecialchars("host.php?action=edit");?>">Create New Host</a>
+				<span style="white-space: nowrap; color: #c16921;">*</span><a href="<?php print htmlspecialchars("host.php?action=edit");?>">Create New Host</a><br>
+				<?php api_plugin_hook('graphs_new_top_links'); ?>
 			</td>
 		</tr>
 	</table>
--- a/host.php
+++ b/host.php
@@ -44,6 +44,8 @@
 	6 => "Change Availability Options"
 	);
 
+$device_actions = api_plugin_hook_function('device_action_array', $device_actions);
+
 /* set default action */
 if (!isset($_REQUEST["action"])) { $_REQUEST["action"] = ""; }
 
@@ -305,6 +307,8 @@
 
 				api_tree_item_save(0, $_POST["tree_id"], TREE_ITEM_TYPE_HOST, $_POST["tree_item_id"], "", 0, read_graph_config_option("default_rra_id"), $selected_items[$i], 1, 1, false);
 			}
+		} else {
+			api_plugin_hook_function('device_action_execute', $_POST['drp_action']); 
 		}
 
 		header("Location: host.php");
@@ -450,6 +454,12 @@
 				<input type='hidden' name='tree_id' value='" . $matches[1] . "'>\n
 				";
 			$save_html = "<input type='button' value='Cancel' onClick='window.history.back()'>&nbsp;<input type='submit' value='Continue' title='Place Device(s) on Tree'>";
+		} else {
+			$save['drp_action'] = $_POST['drp_action'];
+			$save['host_list'] = $host_list;
+			$save['host_array'] = (isset($host_array)? $host_array : array());
+			api_plugin_hook_function('device_action_prepare', $save);
+			$save_html = "<input type='button' value='Cancel' onClick='window.history.back()'>&nbsp;<input type='submit' value='Continue'>";
 		}
 	}else{
 		print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one device.</span></td></tr>\n";
@@ -532,6 +542,8 @@
 	input_validate_input_number(get_request_var("id"));
 	/* ==================================================== */
 
+	api_plugin_hook('host_edit_top');
+
 	if (!empty($_GET["id"])) {
 		$host = db_fetch_row("select * from host where id=" . $_GET["id"]);
 		$header_label = "[edit: " . htmlspecialchars($host["description"]) . "]";
@@ -643,6 +655,7 @@
 					<span style="color: #c16921;">*</span><a href="<?php print htmlspecialchars("graphs_new.php?host_id=" . $host["id"]);?>">Create Graphs for this Host</a><br>
 					<span style="color: #c16921;">*</span><a href="<?php print htmlspecialchars("data_sources.php?host_id=" . $host["id"] . "&ds_rows=30&filter=&template_id=-1&method_id=-1&page=1");?>">Data Source List</a><br>
 					<span style="color: #c16921;">*</span><a href="<?php print htmlspecialchars("graphs.php?host_id=" . $host["id"] . "&graph_rows=30&filter=&template_id=-1&page=1");?>">Graph List</a>
+					<?php api_plugin_hook('device_edit_top_links'); ?>
 				</td>
 			</tr>
 		</table>
@@ -1107,6 +1120,8 @@
 	}
 
 	form_save_button("host.php", "return");
+
+	api_plugin_hook('host_edit_bottom');
 }
 
 function host() {
--- a/include/auth.php
+++ b/include/auth.php
@@ -31,6 +31,9 @@
 }
 
 if (read_config_option("auth_method") != 0) {
+	/* handle alternate authentication realms */
+	api_plugin_hook_function('auth_alternate_realms');
+
 	/* handle change password dialog */
 	if ((isset($_SESSION['sess_change_password'])) && (read_config_option("webbasic_enabled") != "on")) {
 		header ("Location: auth_changepassword.php?ref=" . (isset($_SERVER["HTTP_REFERER"]) ? $_SERVER["HTTP_REFERER"] : "index.php"));
@@ -72,9 +75,9 @@
 			and user_auth_realm.realm_id='$realm_id'")) || (empty($realm_id)))) {
 
 			if (isset($_SERVER["HTTP_REFERER"])) {
-				$goBack = "<td class='textArea' colspan='2' align='center'>( <a href='" . htmlspecialchars($_SERVER["HTTP_REFERER"]) . "'>Return</a> | <a href='logout.php'>Login Again</a> )</td>";
+				$goBack = "<td class='textArea' colspan='2' align='center'>( <a href='" . htmlspecialchars($_SERVER["HTTP_REFERER"]) . "'>Return</a> | <a href='" . $config['url_path'] . "logout.php'>Login Again</a> )</td>";
 			}else{
-				$goBack = "<td class='textArea' colspan='2' align='center'>( <a href='logout.php'>Login Again</a> )</td>";
+				$goBack = "<td class='textArea' colspan='2' align='center'>( <a href='" . $config['url_path'] . "logout.php'>Login Again</a> )</td>";
 			}
 
 			?>
@@ -83,14 +86,14 @@
 			<head>
 				<title>Cacti</title>
 				<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
-				<link href="include/main.css" type="text/css" rel="stylesheet">
+				<link href="<?php echo $config['url_path']; ?>include/main.css" type="text/css" rel="stylesheet">
 			</head>
 			<body>
 			<br><br>
 
 			<table width="450" align='center'>
 				<tr>
-					<td colspan='2'><img src='images/auth_deny.gif' border='0' alt='Access Denied'></td>
+					<td colspan='2'><img src='<?php echo $config['url_path']; ?>images/auth_deny.gif' border='0' alt='Access Denied'></td>
 				</tr>
 				<tr style='height:10px;'><td></td></tr>
 				<tr>
--- a/include/bottom_footer.php
+++ b/include/bottom_footer.php
@@ -21,6 +21,10 @@
  | http://www.cacti.net/                                                   |
  +-------------------------------------------------------------------------+
 */
+
+$oper_mode = api_plugin_hook_function('top_header', OPER_MODE_NATIVE);
+if (($oper_mode == OPER_MODE_NATIVE) || ($oper_mode == OPER_MODE_IFRAME_NONAV)) {
+
 ?>
 			</div>
 			<br>
@@ -32,6 +36,9 @@
 </html>
 
 <?php
+
+}
+
 /* we use this session var to store field values for when a save fails,
 this way we can restore the field's previous values. we reset it here, because
 they only need to be stored for a single page */
--- a/include/config.php
+++ b/include/config.php
@@ -26,6 +26,17 @@
 $database_type = "mysql";
 require('/etc/cacti/debian.php');
 
+/* load up old style plugins here */
+$plugins = array();
+//$plugins[] = 'thold';
+
+/*
+   Edit this to point to the default URL of your Cacti install
+   ex: if your cacti install as at http://serverip/cacti/ this
+   would be set to /cacti/
+*/
+$url_path = "/";
+
 /* Default session name - Session name must contain alpha characters */
 #$cacti_session_name = "Cacti";
 
--- a/include/global.php
+++ b/include/global.php
@@ -93,6 +93,13 @@
 /* built-in snmp support */
 $config["php_snmp_support"] = function_exists("snmpget");
 
+/* set URL path */
+if (! isset($url_path)) { 
+	$url_path = "";
+}
+$config['url_path'] = $url_path;
+define('URL_PATH', $url_path);
+
 /* used for includes */
 $config["base_path"] = strtr(ereg_replace("(.*)[\\\/]include", "\\1", dirname(__FILE__)), "\\", "/");
 $config["library_path"] = ereg_replace("(.*[\\\/])include", "\\1lib", dirname(__FILE__));
@@ -188,15 +195,17 @@
 /* include base modules */
 include("/usr/share/php/adodb/adodb.inc.php");
 include($config["library_path"] . "/database.php");
-include_once($config["library_path"] . "/functions.php");
-include_once($config["include_path"] . "/global_constants.php");
-include_once($config["include_path"] . "/global_arrays.php");
-include_once($config["include_path"] . "/global_settings.php");
 
 /* connect to the database server */
 db_connect_real($database_hostname, $database_username, $database_password, $database_default, $database_type, $database_port);
 
 /* include additional modules */
+include_once($config["library_path"] . "/functions.php");
+include_once($config["include_path"] . "/global_constants.php");
+include_once($config["library_path"] . "/plugins.php");
+include_once($config["include_path"] . "/plugins.php");
+include_once($config["include_path"] . "/global_arrays.php");
+include_once($config["include_path"] . "/global_settings.php");
 include_once($config["include_path"] . "/global_form.php");
 include_once($config["library_path"] . "/html.php");
 include_once($config["library_path"] . "/html_form.php");
@@ -205,6 +214,8 @@
 include_once($config["library_path"] . "/variables.php");
 include_once($config["library_path"] . "/auth.php");
 
+api_plugin_hook("config_insert");
+
 /* current cacti version */
 $config["cacti_version"] = "0.8.7g";
 
--- a/include/global_arrays.php
+++ b/include/global_arrays.php
@@ -22,6 +22,8 @@
  +-------------------------------------------------------------------------+
 */
 
+global $menu;
+
 $messages = array(
 	1  => array(
 		"message" => 'Save Successful.',
@@ -654,4 +656,10 @@
 	GDC_SLASH => "/"
 	);
 
+$plugin_architecture = array(
+	'version' => '2.8'
+	);
+
+api_plugin_hook('config_arrays');
+
 ?>
--- a/include/global_constants.php
+++ b/include/global_constants.php
@@ -173,4 +173,8 @@
 define("SNMP_CMDPHP", 1);
 define("SNMP_WEBUI", 2);
 
-?>
+define('OPER_MODE_NATIVE', 0);
+define('OPER_MODE_RESKIN', 1);
+define('OPER_MODE_IFRAME_NONAV', 2);
+
+?>
\ No newline at end of file
--- a/include/global_form.php
+++ b/include/global_form.php
@@ -22,8 +22,9 @@
  +-------------------------------------------------------------------------+
 */
 
-if (!defined("VALID_HOST_FIELDS")) {
-	define("VALID_HOST_FIELDS", "(hostname|snmp_community|snmp_username|snmp_password|snmp_auth_protocol|snmp_priv_passphrase|snmp_priv_protocol|snmp_context|snmp_version|snmp_port|snmp_timeout)");
+if (!defined('VALID_HOST_FIELDS')) {
+	$string = api_plugin_hook_function('valid_host_fields', '(hostname|snmp_community|snmp_username|snmp_password|snmp_auth_protocol|snmp_priv_passphrase|snmp_priv_protocol|snmp_context|snmp_version|snmp_port|snmp_timeout)');
+	define('VALID_HOST_FIELDS', $string);
 }
 
 /* file: cdef.php, action: edit */
@@ -1190,4 +1191,7 @@
 		"dropdown_sql" => "select id,name from snmp_query order by name"
 		)
 	);
-?>
+
+
+api_plugin_hook('config_form');
+
--- a/include/global_settings.php
+++ b/include/global_settings.php
@@ -1191,4 +1191,6 @@
 		)
 	);
 
+api_plugin_hook('config_settings');
+
 ?>
--- /dev/null
+++ b/include/plugins.php
@@ -0,0 +1,38 @@
+<?php
+
+/*
+ * Copyright (c) 1999-2005 The SquirrelMail Project Team (http://squirrelmail.org)
+ * Licensed under the GNU GPL. For full terms see the file COPYING.
+ */
+
+global $plugin_hooks, $plugins_system;
+$plugin_hooks = array();
+$plugins_system = array('settings', 'boost', 'dsstats');
+
+function use_plugin ($name) {
+	global $config;
+	if (file_exists($config['base_path'] . "/plugins/$name/setup.php")) {
+		include_once($config['base_path'] . "/plugins/$name/setup.php");
+		$function = "plugin_init_$name";
+		if (function_exists($function)) {
+			$function();
+		}
+	}
+}
+
+/**
+ * This function executes a hook.
+ * @param string $name Name of hook to fire
+ * @return mixed $data
+ */
+
+$oldplugins = read_config_option('oldplugins');
+$oldplugins = explode(',', $oldplugins);
+$plugins = array_merge($plugins, $oldplugins);
+
+/* On startup, register all plugins configured for use. */
+if (isset($plugins) && is_array($plugins)) {
+	foreach ($plugins as $name) {
+		use_plugin($name);
+	}
+}
--- a/include/top_header.php
+++ b/include/top_header.php
@@ -22,38 +22,53 @@
  +-------------------------------------------------------------------------+
 */
 
-global $colors;
+global $colors, $config;
+
+$oper_mode = api_plugin_hook_function('top_header', OPER_MODE_NATIVE);
+if ($oper_mode == OPER_MODE_RESKIN) {
+	return;
+}
+
+$page_title = api_plugin_hook_function('page_title', draw_navigation_text("title"));
+
 ?>
 <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
 <html>
 <head>
-	<title><?php echo draw_navigation_text("title");?></title>
-	<link href="include/main.css" type="text/css" rel="stylesheet">
-	<link href="images/favicon.ico" rel="shortcut icon"/>
+	<title><?php echo $page_title; ?></title>
+	<link href="<?php echo $config['url_path']; ?>include/main.css" type="text/css" rel="stylesheet">
+	<link href="<?php echo $config['url_path']; ?>images/favicon.ico" rel="shortcut icon">
 	<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
-	<script type="text/javascript" src="include/layout.js"></script>
+	<script type="text/javascript" src="<?php echo $config['url_path']; ?>include/layout.js"></script>
 	<?php if (isset($refresh)) {
 	print "<meta http-equiv=refresh content=\"" . $refresh["seconds"] . "; url='" . $refresh["page"] . "'\">";
-	}?>
+	}
+	api_plugin_hook('page_head'); ?>
 </head>
 
-<body style="background-image:url('images/left_border.gif');background-repeat:repeat-y;">
+<?php if ($oper_mode == OPER_MODE_NATIVE) {?>
+<body style="background-image:url('<?php print $config['url_path'];?>images/left_border.gif');background-repeat:repeat-y;" <?php print api_plugin_hook_function("body_style", "");?>>
+<?php }else{?>
+<body style="background-image:url('<?php print $config['url_path'];?>images/left_border.gif');background-repeat:repeat-y;" <?php print api_plugin_hook_function("body_style", "");?>>
+<?php }?>
 
 <table width="100%" cellspacing="0" cellpadding="0">
+<?php if ($oper_mode == OPER_MODE_NATIVE) { ;?>
 	<tr style="height:1px;" bgcolor="#a9a9a9">
 		<td valign="bottom" colspan="3" nowrap>
 			<table width="100%" cellspacing="0" cellpadding="0">
-				<tr style="background: transparent url('images/cacti_backdrop.gif') no-repeat center right;">
+				<tr style="background: transparent url('<?php echo $config['url_path']; ?>images/cacti_backdrop.gif') no-repeat center right;">
 					<td id="tabs" valign="bottom">
-						&nbsp;<a href="index.php"><img src="images/tab_console_down.gif" alt="Console" align="absmiddle" border="0"></a><a href="graph_view.php"><img src="images/tab_graphs.gif" alt="Graphs" align="absmiddle" border="0"></a>
-					</td>
+						&nbsp;<a href="<?php echo $config['url_path']; ?>index.php"><img src="<?php echo $config['url_path']; ?>images/tab_console_down.gif" alt="Console" align="absmiddle" border="0"></a><a href="<?php echo $config['url_path']; ?>graph_view.php"><img src="<?php echo $config['url_path']; ?>images/tab_graphs.gif" alt="Graphs" align="absmiddle" border="0"></a><?php
+						api_plugin_hook('top_header_tabs');
+					?></td>
 				</tr>
 			</table>
 		</td>
 	</tr>
 	<tr style="height:2px;" bgcolor="#183c8f">
 		<td colspan="3">
-			<img src="images/transparent_line.gif" style="height:2px;" border="0"><br>
+			<img src="<?php echo $config['url_path']; ?>images/transparent_line.gif" style="height:2px;" border="0"><br>
 		</td>
 	</tr>
 	<tr style="height:5px;" bgcolor="#e9e9e9">
@@ -65,7 +80,7 @@
 					</td>
 					<td align="right">
 						<?php if (read_config_option("auth_method") != 0) { ?>
-						Logged in as <strong><?php print db_fetch_cell("select username from user_auth where id=" . $_SESSION["sess_user_id"]);?></strong> (<a href="logout.php">Logout</a>)&nbsp;
+						Logged in as <strong><?php print db_fetch_cell("select username from user_auth where id=" . $_SESSION["sess_user_id"]);?></strong> (<a href="<?php echo $config['url_path']; ?>logout.php">Logout</a>)&nbsp;
 						<?php } ?>
 					</td>
 				</tr>
@@ -73,10 +88,10 @@
 		</td>
 	</tr>
 	<tr>
-		<td bgcolor="#f5f5f5" colspan="1" style="height:8px;width:135px;background-image: url(images/shadow_gray.gif); background-repeat: repeat-x; border-right: #aaaaaa 1px solid;">
-			<img src="images/transparent_line.gif" style="height:2px;width:135px;" border="0"><br>
+		<td bgcolor="#f5f5f5" colspan="1" style="height:8px;width:135px;background-image: url(<?php echo $config['url_path']; ?>images/shadow_gray.gif); background-repeat: repeat-x; border-right: #aaaaaa 1px solid;">
+			<img src="<?php echo $config['url_path']; ?>images/transparent_line.gif" style="height:2px;width:135px;" border="0"><br>
 		</td>
-		<td colspan="2" style="height:8px;background-image: url(images/shadow.gif); background-repeat: repeat-x;" bgcolor="#ffffff">
+		<td colspan="2" style="height:8px;background-image: url(<?php echo $config['url_path']; ?>images/shadow.gif); background-repeat: repeat-x;" bgcolor="#ffffff">
 
 		</td>
 	</tr>
@@ -86,9 +101,12 @@
 				<?php draw_menu();?>
 			</table>
 
-			<img src="images/transparent_line.gif" style="height:5px;width:135px;" border="0"><br>
-			<p align="center"><a href='about.php'><img src="images/cacti_logo.gif" border="0"></a></p>
-			<img src="images/transparent_line.gif" style="height:5px;width:135px;" border="0"><br>
+			<img src="<?php echo $config['url_path']; ?>images/transparent_line.gif" style="height:5px;width:135px;" border="0"><br>
+			<p align="center"><a href='<?php echo $config['url_path']; ?>about.php'><img src="<?php echo $config['url_path']; ?>images/cacti_logo.gif" border="0"></a></p>
+			<img src="<?php echo $config['url_path']; ?>images/transparent_line.gif" style="height:5px;width:135px;" border="0"><br>
 		</td>
 		<td width="100%" colspan="2" valign="top" style="padding: 5px; border-right: #aaaaaa 1px solid;"><?php display_output_messages();?><div style='position:relative;' id='main'>
-
+<?php }else{ ?>
+	<tr>
+		<td width="100%" valign="top"><?php display_output_messages();?>
+<?php } ?>
--- a/index.php
+++ b/index.php
@@ -25,6 +25,8 @@
 include("./include/auth.php");
 include("./include/top_header.php");
 
+api_plugin_hook('console_before');
+
 ?>
 <table width="100%" align="center">
 	<tr>
@@ -46,6 +48,8 @@
 
 <?php
 
+api_plugin_hook('console_after');
+
 include("./include/bottom_footer.php");
 
 ?>
--- a/lib/api_device.php
+++ b/lib/api_device.php
@@ -137,6 +137,8 @@
 	$save["ping_retries"]         = form_input_validate($ping_retries, "ping_retries", "^[0-9]+$", true, 3);
 	$save["max_oids"]             = form_input_validate($max_oids, "max_oids", "^[0-9]+$", true, 3);
 
+	$save = api_plugin_hook_function('api_device_save', $save);
+
 	$host_id = 0;
 
 	if (!is_error_message()) {
--- a/lib/auth.php
+++ b/lib/auth.php
@@ -121,8 +121,9 @@
 		}
 	}
 
-	return true;
+	api_plugin_hook_function('copy_user', array('template_id' => $template_id, 'new_id' => $new_id));
 
+	return true;
 }
 
 
@@ -152,6 +153,7 @@
 	db_execute("delete from settings_graphs where user_id=" . $user_id);
 	db_execute("delete from settings_tree where user_id=" . $user_id);
 
+	api_plugin_hook_function('user_remove', $user_id);
 }
 
 /* user_disable - disable a user account
--- a/lib/functions.php
+++ b/lib/functions.php
@@ -1689,6 +1689,8 @@
    @arg $type - (string) Either 'url' or 'title'
    @returns (string> Either the navigation text or title */
 function draw_navigation_text($type = "url") {
+	global $config;
+
 	$nav_level_cache = (isset($_SESSION["sess_nav_level_cache"]) ? $_SESSION["sess_nav_level_cache"] : array());
 
 	$nav = array(
@@ -1701,8 +1703,8 @@
 		"graph.php:zoom" => array("title" => "Zoom", "mapping" => "graph_view.php:,?,graph.php:view", "level" => "3"),
 		"graph.php:properties" => array("title" => "Properties", "mapping" => "graph_view.php:,?,graph.php:view", "level" => "3"),
 		"graph_settings.php:" => array("title" => "Settings", "mapping" => "graph_view.php:", "url" => "graph_settings.php", "level" => "1"),
-		"index.php:" => array("title" => "Console", "mapping" => "", "url" => "index.php", "level" => "0"),
-		"index.php:login" => array("title" => "Console", "mapping" => "", "url" => "index.php", "level" => "0"),
+		"index.php:" => array("title" => "Console", "mapping" => "", "url" => $config['url_path'] . "index.php", "level" => "0"),
+		"index.php:login" => array("title" => "Console", "mapping" => "", "url" => $config['url_path'] . "index.php", "level" => "0"),
 		"graphs.php:" => array("title" => "Graph Management", "mapping" => "index.php:", "url" => "graphs.php", "level" => "1"),
 		"graphs.php:graph_edit" => array("title" => "(Edit)", "mapping" => "index.php:,graphs.php:", "url" => "", "level" => "2"),
 		"graphs.php:graph_diff" => array("title" => "Change Graph Template", "mapping" => "index.php:,graphs.php:,graphs.php:graph_edit", "url" => "", "level" => "3"),
@@ -1780,6 +1782,8 @@
 		"templates_import.php:" => array("title" => "Import Templates", "mapping" => "index.php:", "url" => "templates_import.php", "level" => "1"),
 		);
 
+	$nav =  api_plugin_hook_function('draw_navigation_text', $nav);
+
 	$current_page = basename($_SERVER["PHP_SELF"]);
 
 	input_validate_input_regex(get_request_var_request("action"), "^([a-zA-Z0-9_-]+)$");
